/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.techhider;

import de.steamwar.Reflection;
import org.bukkit.entity.Player;

import java.util.function.BiFunction;
import java.util.function.UnaryOperator;

public class ProtocolWrapper14 extends ProtocolWrapper8 {

    @Override
    public BiFunction<Player, Object, Object> blockBreakHiderGenerator(Class<?> blockBreakPacket, TechHider techHider) {
        UnaryOperator<Object> blockBreakCloner = ProtocolUtils.shallowCloneGenerator(blockBreakPacket);
        Reflection.Field<?> blockBreakPosition = Reflection.getField(blockBreakPacket, TechHider.blockPosition, 0);
        Reflection.Field<?> blockBreakBlockData = Reflection.getField(blockBreakPacket, TechHider.iBlockData, 0);

        return (p, packet) -> {
            switch (techHider.getLocationEvaluator().checkBlockPos(p, blockBreakPosition.get(packet))) {
                case SKIP:
                    return packet;
                case CHECK:
                    if(!techHider.iBlockDataHidden(blockBreakBlockData.get(packet)))
                        return packet;
                case HIDE:
                    packet = blockBreakCloner.apply(packet);
                    blockBreakBlockData.set(packet, techHider.getObfuscationTarget());
                    return packet;
                case HIDE_AIR:
                default:
                    packet = blockBreakCloner.apply(packet);
                    blockBreakBlockData.set(packet, TechHider.AIR);
                    return packet;
            }
        };
    }
}
